namespace Excercise01
{
    public partial class Form1 : Form
    {
        Excercise01 ex01;
        Excercise02 ex02;
        Excercise03 ex03;

        Random r;
        System.Windows.Forms.Timer timer;

        public Form1()
        {
            InitializeComponent();
            FormClosed += StopTimer;
            r = new Random();

            canvasBox.Image = new Bitmap(canvasBox.Width, canvasBox.Height);
            ex01 = new Excercise01((Bitmap)canvasBox.Image);
            ex02 = new Excercise02((Bitmap)canvasBox.Image);
            ex03 = new Excercise03((Bitmap)canvasBox.Image);
        }

        private void StopTimer(object? sender, FormClosedEventArgs e)
        {
            if (isRunning)
                timer.Stop();
        }

        private void sandboxBT_Click(object sender, EventArgs e)
        {
            ex01.DrawingSandbox();
            canvasBox.Invalidate();
        }

        bool isRunning = false;
        private void animBT_Click(object sender, EventArgs e)
        {
            if (isRunning)
            {
                timer.Stop();
                isRunning = false;
            }
            else
            {
                timer = new System.Windows.Forms.Timer();
                timer.Interval = 1;
                timer.Tick += new EventHandler(NextStepSquare);
                timer.Enabled = true;
                timer.Start();
                isRunning = true;
            }
        }

        private void NextStepSquare(object? sender, EventArgs e)
        {
            ex01.NextStepSquare();
            canvasBox.Invalidate();
        }

        private void mazeBT_Click(object sender, EventArgs e)
        {
            // generate random number of columns and rows
            // min size of maze is 2x2
            int m = r.Next(30) + 2;
            int n = r.Next(30) + 2;
            // find out maximum size of the cell so the maze still fits the window
            // min padding equals the size of a cells on each side of the maze
            int cellsizeCol = canvasBox.Image.Width / (n + 2);
            int cellsizRow = canvasBox.Image.Height / (m + 2);
            int cellsize = Math.Min(cellsizRow, cellsizeCol);
            ex02.GenerateMaze(m, n, cellsize);
            canvasBox.Invalidate();
        }

        bool lifeInit = false;
        private void lifeBT_Click(object sender, EventArgs e)
        {
            int m = 20;
            int n = 20;
            int cellsizeCol = canvasBox.Image.Width / (n + 2);
            int cellsizRow = canvasBox.Image.Height / (m + 2);
            int cellsize = Math.Min(cellsizRow, cellsizeCol);
            ex03.GenerateLife(m, n, cellsize);
            canvasBox.Invalidate();
            lifeInit = true;
        }

        private void runLifeBT_Click(object sender, EventArgs e)
        {
            if (!lifeInit)
                return;

            if (isRunning)
            {
                timer.Stop();
                isRunning = false;
            }
            else
            {
                timer = new System.Windows.Forms.Timer();
                timer.Interval = 100;
                timer.Tick += new EventHandler(NextStepLife);
                timer.Enabled = true;
                timer.Start();
                isRunning = true;
            }
        }

        private void NextStepLife(object? sender, EventArgs e)
        {
            ex03.NextLifeConfig();
            canvasBox.Invalidate();
        }
    }
}